/*****************************************************************************
*                                                                            *
* void      BildBild(int Funktion)                                           *
*                                                                            *
******************************************************************************
*                                                                            *
* Fuehrt Mehrbild-Operationen (betrifft 2 Quellbilder) durch.                *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 06.11.1992                                               *
* Letzte Aenderung: 12.11.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input: Funktion =1 : Bilder addieren (falls Grauwert >=MAX_COLOR, klippen) *
*                 =2 : Bilder subtrahieren (falls Grauwert<SCHWARZ, klippen) *
*                 =3 : Bilder logisch UND-verknuepfen                        *
*                 =4 : Bilder logisch ODER-verknuepfen                       *
*                 =5 : Differenzbild (bei Differenz wird Pixel von Bild1     *
*                      ausgegeben, bei Gleichheit SCHWARZ).                  *
*                 =6 : Gleichheitstest (bei Differenz wird ein weisser Pixel *
*                      ausgegeben, bei Gleichheit ein schwarzer Pixel)       *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Make_Icon(), Show_Pic()                                        *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void BildBild(int Funktion)
{
  int  BildNr1, BildNr2, BildNr3;  /* Nummern der Quell- und des Zielbildes */
  long z, s;                       /* Zeilen- und Spaltenzaehler            */
  long Index1, Index2, Index3;     /* Anfangsadresse der Bilder             */
  int Z_Res_1, Z_Res_2, Z_Res_Pic; /* Bild-Zeilen-Groessen                  */
  int S_Res_1, S_Res_2, S_Res_Pic; /* Bild-Spalten-Groessen                 */
  int zwerg, zwerg1, zwerg2;       /* Variablen fuer ZWischenERGebnisse     */


  ClearTextWindow(35,18,80,25);

  switch (Funktion) {
     case 1:
         /*----------------------- Zwei Bilder im Grauwert addieren --------*/
         WriteText(35,18,"* Bilder addieren *");
         break;
     case 2:
         /*----------------------- Zwei Bilder im Grauwert subtrahieren ----*/
         WriteText(35,18,"* Bilder subtrahieren *");
         break;
     case 3:
         /*----------------------- Zwei Bilder im Grauwert UNDieren --------*/
         WriteText(35,18,"* Bilder logisch UND *");
         break;
     case 4:
         /*----------------------- Zwei Bilder im Grauwert verODERn --------*/
         WriteText(35,18,"* Bilder logisch ODER *");
         break;
     case 5:
         /*----------------------- Differenzen zweier Bilder anzeigen ------*/
         WriteText(35,18,"* Differenzbild *");
         break;
     case 6:
         /*----------------------- Test auf Gleichheit der Pixel -----------*/
         WriteText(35,18,"* Gleichheitstest *");
         break;
  }

  gotoxy(35,20);
  BildNr1=Read_Int("Quell-Bild 1 ", 1, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr1].Used)   return;

  gotoxy(35,21);
  BildNr2=Read_Int("Quell-Bild 2 ", 2, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr2].Used)   return;

  gotoxy(35,22);
  BildNr3=Read_Int("Ziel-Bild    ", 3, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr3<=0) || (BildNr3>MAX_PICTURE)) return;
  BildNr3--;                          /* die Zaehlung faengt immer bei 0 an */

  Z_Res_1 = Bild[BildNr1].Zeilen;     /* Aufloesung des Quellbildes         */
  S_Res_1 = Bild[BildNr1].Spalten;
  Z_Res_2 = Bild[BildNr2].Zeilen;     /* Aufloesung des Quellbildes         */
  S_Res_2 = Bild[BildNr2].Spalten;

  Z_Res_Pic = (Z_Res_1 > Z_Res_2) ? Z_Res_1 : Z_Res_2;
  S_Res_Pic = (S_Res_1 > S_Res_2) ? S_Res_1 : S_Res_2;

  Index1 = (long) (BildNr1) * PIC_SIZE;  /* Adresse des Quell-Bildes 1      */
  Index2 = (long) (BildNr2) * PIC_SIZE;  /* Adresse des Quell-Bildes 2      */
  Index3 = (long) (BildNr3) * PIC_SIZE;  /* Adresse des Ziel-Bildes         */

  switch (Funktion) {
     case 1:
         /*----------------------- Zwei Bilder im Grauwert addieren --------*/
         for (z=0; z<Z_Res_Pic; z++)
             for (s=0; s<S_Res_Pic; s++) {
                 zwerg  = ((s<S_Res_1) && (z<Z_Res_1)) ? Pictures[Index1++] : 0;
                 zwerg += ((s<S_Res_2) && (z<Z_Res_2)) ? Pictures[Index2++] : 0;
                 /* Klipping durchfuehren falls Grauwert>=MAX_COLOR         */
                 Pictures[Index3++] = (zwerg>=MAX_COLOR) ? WEISS : zwerg;
             }
         break;
     case 2:
         /*----------------------- Zwei Bilder im Grauwert subtrahieren ----*/
         for (z=0; z<Z_Res_Pic; z++)
             for (s=0; s<S_Res_Pic; s++) {
                 zwerg  = ((s<S_Res_1) && (z<Z_Res_1)) ? Pictures[Index1++] : 0;
                 zwerg -= ((s<S_Res_2) && (z<Z_Res_2)) ? Pictures[Index2++] : 0;
                 /* Klipping durchfuehren falls Grauwert<SCHWARZ            */
                 Pictures[Index3++] = (zwerg<SCHWARZ) ? SCHWARZ : zwerg;
             }
         break;
     case 3:
         /*----------------------- Zwei Bilder im Grauwert UNDieren --------*/
         for (z=0; z<Z_Res_Pic; z++)
             for (s=0; s<S_Res_Pic; s++) {
                 zwerg1 = ((s<S_Res_1) && (z<Z_Res_1)) ? Pictures[Index1++] : WEISS;
                 zwerg2 = ((s<S_Res_2) && (z<Z_Res_2)) ? Pictures[Index2++] : WEISS;
                 /* Grauwert binaer bitweise logisch UND-verknpfen         */
                 Pictures[Index3++] = (zwerg1 & zwerg2);
             }
         break;
     case 4:
         /*----------------------- Zwei Bilder im Grauwert verODERn --------*/
         for (z=0; z<Z_Res_Pic; z++)
             for (s=0; s<S_Res_Pic; s++) {
                 zwerg1 = ((s<S_Res_1) && (z<Z_Res_1)) ? Pictures[Index1++] : SCHWARZ;
                 zwerg2 = ((s<S_Res_2) && (z<Z_Res_2)) ? Pictures[Index2++] : SCHWARZ;
                 /* Grauwert binaer bitweise logisch ODER-verknpfen        */
                 Pictures[Index3++] = (zwerg1 | zwerg2);
             }
         break;
     case 5:
         /*----------------------- Differenzen zweier Bilder anzeigen ------*/
         for (z=0; z<Z_Res_Pic; z++)
             for (s=0; s<S_Res_Pic; s++) {
                 zwerg1 = ((s<S_Res_1) && (z<Z_Res_1)) ? Pictures[Index1++] : SCHWARZ;
                 zwerg2 = ((s<S_Res_2) && (z<Z_Res_2)) ? Pictures[Index2++] : SCHWARZ;
                 /* Differenzbild berechnen. Bei Gleichheit wird SCHWARZ ...*/
                 /* ... ausgegeben, bei Unterschieden Pixel aus Bild1       */
                 Pictures[Index3++] = (zwerg1 != zwerg2) ? zwerg1 : SCHWARZ;
             }
         break;
     case 6:
         /*----------------------- Test auf Gleichheit der Pixel -----------*/
         for (z=0; z<Z_Res_Pic; z++)
             for (s=0; s<S_Res_Pic; s++) {
                 zwerg1 = ((s<S_Res_1) && (z<Z_Res_1)) ? Pictures[Index1++] : SCHWARZ;
                 zwerg2 = ((s<S_Res_2) && (z<Z_Res_2)) ? Pictures[Index2++] : SCHWARZ;
                 /* Gleichheit testen. Bei Gleichheit wird SCHWARZ ...      */
                 /* ... ausgegeben, bei Unterschieden WEISS.                */
                 Pictures[Index3++] = (zwerg1 == zwerg2) ? SCHWARZ : WEISS;
             }
         break;
  }

  /* Parameter des Ergebnisbildes setzen und ...                            */
  Bild[BildNr3].Spalten=S_Res_Pic;
  Bild[BildNr3].Zeilen =Z_Res_Pic;
  Bild[BildNr3].Used   =TRUE;
  Bild[BildNr3].Color  =FALSE;

  /* ... Ergebnis anzeigen.                                                 */
  Make_Icon(BildNr3);
  Show_Pic(BildNr3, BildNr3+1);

}
