/******************************* Alle INCLUDE-Dateien ***********************/
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <dir.h>
#include <alloc.h>
#include <conio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <io.h>
#include <sys\stat.h>
#include <fcntl.h>
#include <graphics.h>


/******************************* Konstanten-Definition **********************/
#define MAX_PICTURE    4        /* Maximale Anzahl von Bilder verfuegbar    */

#define S_RES_MAX    256        /* Maximale Aufloesung in horizontaler Rich.*/
#define Z_RES_MAX    256        /* Maximale Aufloesung in vertikaler Richt. */
#define PIC_SIZE   65536        /* 256x256 = max. Groesse eines Bildes      */
#define REDUK_FAKT     4
#define ICON_SIZE     64

#define POS_OFFSET   320        /* horizontaler Offset fuer das 2. Bild     */

#define GRAPH_MODE   0x2E       /* Graphik-Modus 640x480 bei 256 Farben     */
#define TEXT_MODE    0x03       /* Standard-Text-Modus 720x400 bei 16 Farben*/
#define SCREEN_SIZE   640       /* horizontale Aufloesung im Modus 0x2E     */

#define MAX_COLOR    256        /* maximale Anzahl verschiedener Farben     */

#define ROT            0
#define GRUEN          1
#define BLAU           2
#define SCHWARZ        0
#define GRAU         128
#define WEISS        255
#define CLIP_COLOR     8

#define LINE_LENGTH  131

#define TRUE           1
#define FALSE          0

#define HEADERSIZE    10
#define PCX_HEADERSIZE  128

#define      INT_NO_DEFAULT    -32760   /* unbenutzter int-Wert   */
#define      FLOAT_NO_DEFAULT  -1E+20   /* unbenutzter float-Wert */

#define      EPS_ERROR          1E-10   /* Genauigkeitsschrankle bei FLOAT */
#define      PI         3.14159265359

#define      _fmode   O_BINARY

#define NO_CURS_POS    0

#define HARDCOPY     -99

#define ESC           27        /* Escape          */
#define FF            12        /* Form-Feed       */
#define CR            10        /* Carriage-Return */



/******************************* Variablen-Definition ***********************/
typedef struct                   /* Struktur fuer die RBG-Farbanteile       */
{
  unsigned char Rot, Gruen, Blau;
} rgb;

typedef struct                       /* Daten zu den einzelnen Bildern      */
{
  int           Zeilen;              /* Aufloesung vertikal      */
  int           Spalten;             /* Aufloesung horizontal    */
  unsigned char Used;                /* Flag, ob Bild benutzt    */
  unsigned char Color;               /* Flag, ob Bild mit Farbe  */
  unsigned char Icon[ICON_SIZE][ICON_SIZE];
} BildInfo;


#if !defined(MAIN)

extern union  REGS  pc_cpu;          /* Strukturen zur Verwend. der CPU-Reg.*/
extern struct SREGS s_cpu;

extern unsigned char far *vgaram;   /* Far-Pointer fuer den VGA-Bildschirm  */

extern unsigned char huge *Pictures;/* Huge-Pointer auf MAX_PICTURE Bilder  */

extern BildInfo  Bild[MAX_PICTURE];

#endif
