/*****************************************************************************
*                                                                            *
* void      Copy_Picture(int BildNr1, int BildNr2)                           *
*                                                                            *
******************************************************************************
*                                                                            *
* Kopiert (dupliziert) ein Bild im Speicher.                                 *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 30.09.1992                                               *
* Letzte Aenderung: 10.10.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input: BildNr1 = Nummer des Ausgangsbildes (1<=BildNr1<=MAX_PICTURE).      *
*        BildNr2 = Nummer des Zielbildes (1<=BildNr2<=MAX_PICTURE).          *
*                                                                            *
*        Falls eine BildNr==FALSE, dann wird diese erfragt.                  *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(), Show_Pic()         *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Copy_Picture(int BildNr1, int BildNr2)
{
  long z, s;              /* Zeilen- und Spaltenzaehler                     */
  long Index1, Index2;    /* Anfangsadresse von Bild 1 und Bild 2           */

  /* Titel nur anzeigen, falls keine bzw. falsche Parameter angegeben       */
  if ((BildNr1==FALSE) || (BildNr2==FALSE)) {
     ClearTextWindow(35,18,80,25);
     WriteText(35,18,"* Bild kopieren/duplizieren *");
  }

  if (BildNr1 == FALSE) {
     gotoxy(35,20);
     BildNr1=Read_Int("Quell-Bild ", 1, ':');
  }
  /* Gueltige Bild-Nummer eingegeben? Ist dieses Bild ueberhaupt benutzt?   */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr1].Used) return;

  if (BildNr2 == FALSE) {
     gotoxy(35,21);
     BildNr2=Read_Int("Ziel-Bild  ", 2, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt immer bei 0 an */

  Index1 = (long) (BildNr1) * PIC_SIZE;  /* Anfangsadressen der beiden ...  */
  Index2 = (long) (BildNr2) * PIC_SIZE;  /* ... Bilder.                     */

  /* Ausgangsbild komplett in das Zielbild kopieren                         */
  for (s=0; s<PIC_SIZE; s++)
      Pictures[Index2++]=Pictures[Index1++];

  /* Jetzt die Bildinformation fuer das neue Bild korrekt setzen            */
  Bild[BildNr2].Zeilen =Bild[BildNr1].Zeilen;
  Bild[BildNr2].Spalten=Bild[BildNr1].Spalten;
  Bild[BildNr2].Used   =Bild[BildNr1].Used;
  Bild[BildNr2].Color  =Bild[BildNr1].Color;

  /* Das Icon laesst sich so schneller als ueber Make_Icon() erzeugen       */
  for (z=0; z<ICON_SIZE; z++)
      for (s=0; s<ICON_SIZE; s++)
          Bild[BildNr2].Icon[z][s]=Bild[BildNr1].Icon[z][s];

  Show_Pic(BildNr2, BildNr2+1);

}
