/*****************************************************************************
*                                                                            *
* main      DBV()                                                            *
*                                                                            *
******************************************************************************
*                                                                            *
* Sammlung von Routinen der Digitalen Bildverarbeitung (DBV).                *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 30.09.1992                                               *
* Letzte Aenderung: 28.05.1993                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von:  Init_Var(), Graph_Mode(), Set_LUT(), ClearTextWindow(),       *
*              Text_Mode(), WriteText(), Read_Int(),                         *
*              Read_Save_Menue(), Histogramm_Menue(), Geometrie_Menue(),     *
*              Mehrbild_Menue(), Glaettungs_Menue(), Edge_Menue(),           *
*              Morphol_Menue(), Transform_Menue(), Divers_Menue()            *
*                                                                            *
*****************************************************************************/

#define  MAIN

#include "const.h"

#include "prototyp.h"


/******************************* Variablen-Definition ***********************/
union  REGS  pc_cpu;             /* Strukturen zur Verwendung der CPU-Reg.  */
struct SREGS s_cpu;

unsigned char far *vgaram;       /* Far-Pointer fuer den VGA-Bildschirmsp.  */

unsigned char huge *Pictures;    /* Far-Pointer auf die MAX_PICTURE Bilder  */

BildInfo  Bild[MAX_PICTURE];     /* Groessenangaben etc. zu den Bildern     */


void main()
{
  int Auswahl;

  /*---------------------------- Initialisierung ---------------------------*/
  Init_Var();                    /* Alle Variablen und Bilder initialisieren*/
  Graph_Mode();                  /* Graphik-Modus einschalten bis zum Ende  */
  Set_LUT();                     /* LUT auf Graukeil mit einzelnen Farben   */

  /*---------------------------- Hauptmenue anzeigen -----------------------*/
  Auswahl = 1;
  while ((Auswahl>0) && (Auswahl<=9)) {
        ClearTextWindow(35,18,80,25);
        WriteText(35,18,">>> DBV - Version 0.8 vom 28.05.93 <<<");

        WriteText(35,20,"(1)  Bild einl./speich.  (5)  Glaettungsfilter");
        WriteText(35,21,"(2)  Histogramm-Operat.  (6)  Kantendetektion");
        WriteText(35,22,"(3)  Geometrische Oper.  (7)  Morpholog. Oper.");
        WriteText(35,23,"(4)  Mehrbild-Operat.    (8)  Bildtransformat.");
        WriteText(60,24,                         "(9)  Sonstige Funkt.");
        gotoxy(35,25);
        Auswahl=Read_Int("Bitte Auswahl angeben (0=Ende): ", 1, ' ');

        switch (Auswahl) {
           case 1:
               /*----------------- Bild einlesen/speichern -----------------*/
               Read_Save_Menue();
               break;
           case 2:
               /*------------------ Histogramm-Operationen -----------------*/
               Histogramm_Menue();
               break;
           case 3:
               /*----------------- Geometrische Operationen ----------------*/
               Geometrie_Menue();
               break;
           case 4:
               /*------------------- Mehrbild-Operationen ------------------*/
               Mehrbild_Menue();
               break;
           case 5:
               /*--------------------- Glaettungsfilter --------------------*/
               Glaettungs_Menue();
               break;
           case 6:
               /*--------------------- Kantendetektion ---------------------*/
               Edge_Menue();
               break;
           case 7:
               /*----------------- Morphologische Operatoren ---------------*/
               Morphol_Menue();
               break;
           case 8:
               /*------------------ Bildtransformationen -------------------*/
               Transform_Menue();
               break;
           case 9:
               /*------------------ Sonstige Operationen -------------------*/
               Divers_Menue();
               break;
        } /* switch */

        /* Speichere kompletten Bildschirminhalt in die Datei  VGA.PCX  ab  */
        if (Auswahl==HARDCOPY) Save_VGA();
  }

  Text_Mode();                   /* ... und wieder in den Textmodus zurueck */

}
