/*****************************************************************************
*                                                                            *
* void      EdgeEnhance(int BildNr1, int BildNr2)                            *
*                                                                            *
******************************************************************************
*                                                                            *
* Berechnet eine Kantenverstrkung mit einem variablen Faktor.               *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 12.11.1992                                               *
* Letzte Aenderung: 13.11.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input:  BildNr1 = Nummer des zu bearbeitenden Bildes                       *
*         BildNr2 = Nummer des Ziel-Bildes                                   *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Make_Icon(), Show_Pic(), Geduld()                              *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void EdgeEnhance(int BildNr1, int BildNr2)
{
  long Index, Index1, Index2 ;     /* Adresse des Bildes                   */
  long s, z;
  long Smax, Zmax;
  unsigned char Pixel;
  float zwerg, Alpha, Ein_Neuntel;


  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Kantenverstaerkung *");

  if (!BildNr1) {
     gotoxy(35,20);
     BildNr1=Read_Int("Quell-Bild ", 1, ':');
  }
  /* Gueltige Bild-Nummer eingegeben? Falls nicht, dann Abbruch             */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr1].Used)   return;

  if (!BildNr2) {
     gotoxy(35,21);
     BildNr2=Read_Int("Ziel-Bild  ", 2, ':');
  }
  /* Gueltige Bild-Nummer eingegeben? Falls nicht, dann Abbruch             */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt immer bei 0 an */
  Index1 = (long) (BildNr1) * PIC_SIZE; /* Adresse des Quell-Bildes         */
  Index2 = (long) (BildNr2) * PIC_SIZE; /* Adresse des Ziel-Bildes          */

  /* Nun Faktor alpha einlesen (siehe ACM Transactions on Graphics Vol. 6) */
  WriteText(35,22,"Bitte Faktor ALPHA eingeben");
  do {
      gotoxy(35,23);
      Alpha = Read_Float("Wertebereich (0.0-0.99) ", 0.75, ':' );
  } while ((Alpha<0.0) || (Alpha>=1.0));

  Geduld();

  Ein_Neuntel = 1.0 / 9.0;

  Zmax = (long) Bild[BildNr1].Zeilen;
  Smax = (long) Bild[BildNr1].Spalten;

  /* Originalbild zuerst einmal ins Zielbild kopieren                       */
  for (z=0; z<(Zmax*Smax); z++) Pictures[Index2+z]=Pictures[Index1+z];

  /* 8 Nachbarn aufsummieren und durch 9 teilen. Rand bleibt unveraendert   */
  for (z=1; z<(Zmax-1); z++) {
      for (s=1; s<(Smax-1); s++) {
           Index  =Index1+(z-1)*Smax;
           zwerg  =(float) ( (int)Pictures[Index+(s-1)] +
                             (int)Pictures[Index+(s  )] +
                             (int)Pictures[Index+(s+1)] );
           Index  =Index1+(z  )*Smax;
           zwerg +=(float) ( (int)Pictures[Index+(s-1)] +
                             (int)Pictures[Index+(s  )] +
                             (int)Pictures[Index+(s+1)] );
           Pixel  =Pictures[Index+s];
           Index  =Index1+(z+1)*Smax;
           zwerg +=(float) ( (int)Pictures[Index+(s-1)] +
                             (int)Pictures[Index+(s  )] +
                             (int)Pictures[Index+(s+1)] );
           zwerg = Ein_Neuntel * zwerg;

           zwerg=( (float)Pixel - Alpha*zwerg ) / (1.0-Alpha);
           if      (zwerg>(float)WEISS)   zwerg=(float)WEISS;
           else if (zwerg<(float)SCHWARZ) zwerg=(float)SCHWARZ;

           Pictures[Index2+z*Smax+s]=(unsigned char)zwerg;
      }
  }

  Bild[BildNr2].Zeilen =Bild[BildNr1].Zeilen;
  Bild[BildNr2].Spalten=Bild[BildNr1].Spalten;
  Bild[BildNr2].Used   =TRUE;
  Bild[BildNr2].Color  =Bild[BildNr1].Color;

  Make_Icon(BildNr2);
  Show_Pic(BildNr2, BildNr2+1);

}
