/*****************************************************************************
*                                                                            *
* void Median_NxM(int BildNr1, int BildNr2, int Groesse_M, int Groesse_N)    *
*                                                                            *
******************************************************************************
*                                                                            *
* Medianfilterung in einem rechteckigen Bereich von MxN                      *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 02.11.1992                                               *
* Letzte Aenderung: 02.11.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input: BildNr1   = Quelbild                                                *
*        BildNr2   = Zielbild (Gradientenbild)                               *
*        Groesse_M = Groesse des Fensters                                    *
*        Groesse_N = Groesse                                                 *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Geduld(), Median_Wert(), Make_Icon(), Show_Pic()               *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Median_MxN(int BildNr1, int BildNr2, int Groesse_M, int Groesse_N)
{
  long  z, s, Z_Temp, S_Temp;     /* Variablen fuer Zeilen und Spaltenindex */
  long  Index1, Index2, Index;    /* Adresse der beiden Bilder              */
  int   i, j, k;
  int   Pixelzahl;
  unsigned char Pixelvektor[50];  /* maximal 7*7=47 Werte zu sortieren      */
  long  Zmax, Smax;


  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Glaettung durch MxN Medianfilter *");

  if (!BildNr1) {
     gotoxy(35,20);
     BildNr1=Read_Int("Quell-Bild            ", 1, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr1].Used)   return;

  if (!BildNr2) {
     gotoxy(35,21);
     BildNr2=Read_Int("Median-Bild           ", 2, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt immer bei 0 an */


  while ((Groesse_M!=3) && (Groesse_M!=5) && (Groesse_M!=7)) {
     gotoxy(35,22);
     Groesse_M=Read_Int("Filtergr.hor. (3,5,7) ", 3, ':');
  }
  while ((Groesse_N!=3) && (Groesse_N!=5) && (Groesse_N!=7)) {
     gotoxy(35,23);
     Groesse_N=Read_Int("Filtergr.vert.(3,5,7) ", 3, ':');
  }
  Pixelzahl=Groesse_M*Groesse_N;
  Groesse_M=(int)(Groesse_M/2);
  Groesse_N=(int)(Groesse_N/2);

  Index1 = (long) (BildNr1) * PIC_SIZE; /* Adresse der beiden Bilder        */
  Index2 = (long) (BildNr2) * PIC_SIZE;

  Zmax = Bild[BildNr1].Zeilen;
  Smax = Bild[BildNr1].Spalten;

  Geduld();

  for (z=0; z<Zmax; z++) {
      for (s=0; s<Smax; s++) {
          k=0;
          /* Pixel im Fenster aufsammeln. Besondere Vorkehrung am Rand.     */
          for (i= -Groesse_M; i<=Groesse_M; i++) {
              Z_Temp=z+i;
              if      (Z_Temp<0)     Z_Temp= -Z_Temp-1;
              else if (Z_Temp>=Zmax) Z_Temp=z-i+1;
              Z_Temp=Z_Temp*Smax;
              for (j= -Groesse_N; j<=Groesse_N; j++) {
                  S_Temp=s+j;
                  if      (S_Temp<0)     S_Temp= -S_Temp-1;
                  else if (S_Temp>=Smax) S_Temp=s-j+1;
                  Index=Index1+Z_Temp+S_Temp;
                  Pixelvektor[k++]=Pictures[Index];
              }
          }
          Pictures[Index2++]=Median_Wert(Pixelvektor, Pixelzahl, Pixelzahl/2);
      }
  }

  /* Bildinformation zum Schluss korrekt setzen                             */
  Bild[BildNr2].Zeilen =Zmax;
  Bild[BildNr2].Spalten=Smax;
  Bild[BildNr2].Used   =TRUE;
  Bild[BildNr2].Color  =FALSE;

  Make_Icon(BildNr2);
  Show_Pic(BildNr2, BildNr2+1);
}

/****************************************************************************/
/* Sortierroutine      siehe  Wirth  Algorithmen+Datenstrukturen  Seite 104 */
/****************************************************************************/
/* Quick-Sort                                                               */
/* ==========                                                               */
/* Pixelvektor[] = Vektor mit den zu sortierenden Werten                    */
/* Pixelzahl     = Laenge des zu sortierenden Vektors (N*N-1)               */
/* Median_Pos    = Psotion des Medianwertes (Median_Pos=(Pixelzahl)/2)      */

Median_Wert(unsigned char Pixelvektor[], int Pixelzahl, int Median_Pos)
{
  int i,j,l,r,x,w,s;           /* Hilfs-Indizes zur Sortierung              */
  unsigned char stack[50][2];  /* lokaler "Stack", da nicht rekursives Vorg.*/

  s=0;
  stack[0][0]=0;
  stack[0][1]=Pixelzahl;
  do {
     l=stack[s][0];
     r=stack[s][1];
     s--;
     do {
        i=l;
        j=r;
        x=Pixelvektor[(l+r)/2];
        do {
           while (Pixelvektor[i] < x) { i++; }
           while (x < Pixelvektor[j]) { j--; }
           if (i<=j) {                     /* Dann muss Sortierung erfolgen */
              w=Pixelvektor[i];            /* Werte vertauschen             */
              Pixelvektor[i]=Pixelvektor[j];
              Pixelvektor[j]=w;
              i++;
              j--;
           }
        } while (i <= j);
        if (i<r) {
           s++;
           stack[s][0]=i;
           stack[s][1]=r;
        }
        r=j;
     } while (l < r);
  } while (s >= 0);

  return(Pixelvektor[Median_Pos]);       /* "mittlerer" Wert zurueckliefern */
}
