/*****************************************************************************
*                                                                            *
* void      Rauschen(int BildNr, int Prozent)                                *
*                                                                            *
******************************************************************************
*                                                                            *
* Aendert Prozent Pixel im Grauwert durch einen Zufallsprozess (Rauschen).   *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 12.11.1992                                               *
* Letzte Aenderung: 12.11.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input:  BildNr = Nummer des zu bearbeitenden Bildes                        *
*         Prozent= Prozentzahl der Pixel die geaendert werden sollen         *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Make_Icon(), Show_Pic()                                        *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Rauschen(int BildNr, int Prozent)
{
  long Index;                       /* Adresse des Bildes                   */
  long Pixelzahl;
  long z;
  int Smax, Zmax;                   /* Spalten-/Zeilen-Zahl des Bildes      */
  int S_Index, Z_Index;             /* Variablen fuer Zufalls-Index         */
  unsigned char Pixel;              /* Zufalls-Grauwert der addiert wird    */


  if (!BildNr) {
     ClearTextWindow(35,18,80,25);
     WriteText(35,18,"* Rauschen erzeugen *");

     gotoxy(35,20);
     BildNr=Read_Int("Bild Nr.                 ", 1, ':');
  }
  /* Gueltige Bild-Nummer eingegeben? Falls nicht, dann Abbruch             */
  if ((BildNr<=0) || (BildNr>MAX_PICTURE)) return;
  BildNr--;                           /* die Zaehlung faengt immer bei 0 an */

  if (Prozent == FALSE) {
     gotoxy(35,22);
     Prozent = Read_Int( "Wieviel Prozent Rauschen", INT_NO_DEFAULT, ':' );
  }

  Index  = (long) (BildNr) * PIC_SIZE;  /* Adresse des Quell-/Zielbildes    */

  Zmax = Bild[BildNr].Zeilen;
  Smax = Bild[BildNr].Spalten;
  Pixelzahl = ( (long)(Zmax) * (long)(Smax) * (long)(Prozent) ) / 100;

  for (z=0; z<Pixelzahl; z++) {
      Z_Index= (int)((float)rand()/32768.0*(float)Zmax);  /* Zufalls-Zeile  */
      S_Index= (int)((float)rand()/32768.0*(float)Smax);  /* Zufalls-Spalte */
      Pixel  = rand() % 256;                   /* Zufalls-Grauwert (additiv)*/
      Pictures[Index + (long)Z_Index*(long)Smax + (long)S_Index] += Pixel;
  }

  /* Ergebnisbild anzeigen                                                  */
  Make_Icon(BildNr);
  Show_Pic(BildNr, BildNr+1);

}
