/*****************************************************************************
*                                                                            *
* void      Read_PCX_Picture()                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Liest ein PCX-Bild ein.                                                    *
*                                                                            *
* Folgende Modi werden verarbeitet:  5
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 30.09.1992                                               *
* Letzte Aenderung: 29.05.1993                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Get_PCX_Byte() (lokal)                                         *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"

#define BUFFER_SIZE 2000


int Read_PCX_Picture()
{
  int Anzahl;
  unsigned char PCXHeader[PCX_HEADERSIZE]; /* PCX-Bild-Header               */
  unsigned char RLC[BUFFER_SIZE];          /* Hilfspuffer fuer Run-Length-C.*/
  unsigned char Pixel;
  int PCX_fd;                              /* File-Descriptor               */
  int i, j, z, s, Bild_Nummer, Buffer_Index;
  long Index;
  char Filename[LINE_LENGTH];              /* Name Ziel-Datei (.PCX)        */
  char *PCX_Ext  =".pcx";

  int NoFileFound;

  int Z_Reduktion, S_Reduktion, Z_Res, S_Res;/* Zeilen- u. Spaltenaufloesung*/
  int Spaltenzahl, S_Cut, Z_Cut;           /* zur Begrenzung der Bildgroesse*/
  unsigned char Temp_Buff[1300];           /* Hilfspuffer beim Zeilen einl. */

  unsigned char Get_PCX_Byte(unsigned char RLC[], int *Buffer_Index, int PCX_fd);

  struct ffblk File_Blk;                   /* Struktur des DIR-Blocks       */

  /*---------------------------- Dateiname eingeben ------------------------*/
  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Bild im PCX-Format einlesen *");

  gotoxy(35,20);
  Bild_Nummer=Read_Int("In welches Bild Nr. (0=Abbruch): ", 1, ' ');

  /* Gueltige Bild-Nummer eingegeben?                                      */
  if ((Bild_Nummer<=0) || (Bild_Nummer>MAX_PICTURE)) {
     return(FALSE);
  }
  Bild_Nummer--;                           /* die Zaehlung faengt bei 0 an */

  /*---------------------------- Dateiname eingeben ------------------------*/
  ClearTextWindow(35,20,80,25);
  i=35;
  j=20;
  NoFileFound = findfirst("*.pcx", &File_Blk, 0);  /* alle .PCX-Dateien anz.*/
  while (!NoFileFound) {
     WriteText( i, j, File_Blk.ff_name);
     NoFileFound=findnext(&File_Blk);
     j++;
     if (j==24) {
        j=20;
        i=i+15;
        if (i>70) NoFileFound=TRUE;
     }
  }

  gotoxy(35,25);
  Read_String("Bitte Dateinamen eingeben: ", Filename);
  if (!Add_Extension(Filename, PCX_Ext)) return(FALSE);

  if ( (PCX_fd=open(Filename, O_RDONLY | O_BINARY)) == -1) {
     ShowError("Fehler beim Oeffnen der Datei.");
     return(FALSE);
  }

  Geduld();

  read(PCX_fd, PCXHeader, PCX_HEADERSIZE );      /* liest PCX-Header und berechnet ... */

  /*---------------------------- PCX-Header --------------------------------*/
  /*PCXHeader[ 0] = 10;        10=0Ah = Zsoft PCX file                      */
  /*PCXHeader[ 1] =  5;        Versionsnummer; d.h. 256 Farben oder 16.7 Mio*/
  /*PCXHeader[ 2] =  1;        Encoding; 1=PCX-run-length encoding          */
  /*PCXHeader[ 3] =  8;        Bits pro Pixel und Ebene                     */
  /*for (i=16; i<64; i++) PCXHeader[i] = 0;  Farbtabelle fuer 16 oder wenig.*/

  /*PCXHeader[65] =  1;        Anzahl der Ebenen                            */

  if ( (PCXHeader[0]!=10) || (PCXHeader[1]!=5) ||
       (PCXHeader[2]!= 1) || (PCXHeader[3]!=8) ) {
     ShowError("Falsches Datenformat.");
     return(FALSE);
  }


  /* ... die Bildmasse. High-Low-Byte   */
  S_Res = 256*(int)PCXHeader[ 9]+(int)PCXHeader[ 8]+1;
  Z_Res = 256*(int)PCXHeader[11]+(int)PCXHeader[10]+1;

  /* Clipping der Zeilen und Spalten auf die maximal verfuegbare Groesse    */
  if (S_Res>S_RES_MAX) S_Cut=S_RES_MAX;
  else                 S_Cut=S_Res;
  S_Reduktion=S_Res/S_Cut;
  Spaltenzahl=S_Res;
  if (S_Reduktion == 1) Spaltenzahl=S_Cut;
  if (Z_Res>Z_RES_MAX) Z_Cut=Z_RES_MAX;
  else                 Z_Cut=Z_Res;
  Z_Reduktion=Z_Res/Z_Cut;

  Index = (long) (Bild_Nummer) * PIC_SIZE;
  z=0;
  Buffer_Index=BUFFER_SIZE;
  while (z<Z_Res) {
        s=0;
        j=0;
        while (s<S_Res) {
              Anzahl=Get_PCX_Byte(RLC, &Buffer_Index, PCX_fd);
              if (Anzahl > 192) {
                 Anzahl=Anzahl-192;
                 Pixel=Get_PCX_Byte(RLC, &Buffer_Index, PCX_fd);
                 for (i=0; i<Anzahl; i++) {
                     Temp_Buff[j++]=Pixel;
                     s++;
                 }
               } else {
                 Temp_Buff[j++]=Anzahl;
                 s++;
               }
        }

        if ((z % Z_Reduktion) == 0) {
           if (S_Reduktion==2)
              for (j=0; j<Spaltenzahl; j+=S_Reduktion) Pictures[Index++]=(Temp_Buff[j]+Temp_Buff[j+1])/2;
           else
              for (j=0; j<Spaltenzahl; j+=S_Reduktion) Pictures[Index++]=Temp_Buff[j];
        }
        z++;
  }
  close(PCX_fd);

  /* Genaue Bildabmessungen in Struktur speichern                           */
  Bild[Bild_Nummer].Zeilen =Z_Cut;
  Bild[Bild_Nummer].Spalten=S_Cut;
  Bild[Bild_Nummer].Used   =TRUE;
  Bild[Bild_Nummer].Color  =FALSE;

  Make_Icon(Bild_Nummer);

  Show_Pic(Bild_Nummer, Bild_Nummer+1);

  return(TRUE);
}


/* Routine zum Optimieren des zeichenweisen Einlesens des RLC-Bildes.       */
unsigned char Get_PCX_Byte(unsigned char RLC[], int *Buffer_Index, int PCX_fd)
{

  /* Falls Start oder Puffer-Ende erreicht, dann neuen Block einlesen       */
  if (*Buffer_Index == BUFFER_SIZE) {
     read(PCX_fd, RLC, BUFFER_SIZE);
     *Buffer_Index=0;
  }

  return(RLC[(*Buffer_Index)++]);/* Zeichen zurueckgeben, Pointer erhoehen */
}
