/*****************************************************************************
*                                                                            *
* void      Spiegelung()                                                     *
*                                                                            *
******************************************************************************
*                                                                            *
* Spiegelt ein Bild an der horizontalen oder vertikalen Mittelachse.         *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 10.10.1992                                               *
* Letzte Aenderung: 10.10.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Make_Icon(), Show_Pic()                                        *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Spiegelung()
{
  int  BildNr;                     /* Nummer des zu spiegelnden Bildes      */
  long z, s;                       /* Zeilen- und Spaltenzaehler            */
  long Index;                      /* Anfangsadresse des Bildes             */
  int  Z_Res_Pic, S_Res_Pic;       /* Aufloesung des zu spiegelnden Bildes  */
  int  Pixel;                      /* temporaerer Bildpunkt                 */
  int  Achse;                      /* Spiegelachse; 1=horiz. 2=vertik.      */


  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Bild spiegeln *");

  gotoxy(35,20);
  BildNr=Read_Int("Bild Nr.  ", 1, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr<=0) || (BildNr>MAX_PICTURE)) return;
  BildNr--;                           /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr].Used)   return;

  Achse = -1;
  WriteText(35,22, "An welcher Mittelachse spiegeln:");
  do {
     gotoxy(35,23);
     Achse=Read_Int("1=horizontal; 2=vertikal ", 1, ':');
  } while ((Achse<0) || (Achse>2));
  if (Achse==FALSE) return;              /* Achse=0 als Abbruch erlaubt.    */

  Z_Res_Pic = Bild[BildNr].Zeilen;       /* Aufloesung des Quellbildes      */
  S_Res_Pic = Bild[BildNr].Spalten;

  Index = (long) (BildNr) * PIC_SIZE;    /* Adresse des Bildes              */

  if (Achse==2) {                 /* an der vertikalen Mittelachse spiegeln */
     for (z=0; z<Z_Res_Pic; z++)
         for (s=0; s<S_Res_Pic/2; s++) {
             Pixel = Pictures[Index + z*(long)Z_Res_Pic + s];
             Pictures[Index + z*(long)Z_Res_Pic + s] =
                     Pictures[Index + z*(long)Z_Res_Pic + S_Res_Pic-s-1];
             Pictures[Index + z*(long)Z_Res_Pic + S_Res_Pic-s-1] = Pixel;
         }
  }
  else {                        /* an der horizontalen Mittelachse spiegeln */
     for (z=0; z<Z_Res_Pic/2; z++)
         for (s=0; s<S_Res_Pic; s++) {
             Pixel = Pictures[Index + z*(long)Z_Res_Pic + s];
             Pictures[Index + z*(long)Z_Res_Pic + s] =
                     Pictures[Index + ((long)Z_Res_Pic-z-1)*(long)Z_Res_Pic + s];
             Pictures[Index + ((long)Z_Res_Pic-z-1)*(long)Z_Res_Pic + s] = Pixel;
        }
  }

  /* Icon erzeugen und Bild anzeigen.                                       */
  Make_Icon(BildNr);
  Show_Pic(BildNr, BildNr+1);

}
