/*****************************************************************************
*                                                                            *
* void      Swap_Picture(int BildNr1, int BildNr2)                           *
*                                                                            *
******************************************************************************
*                                                                            *
* Vertauscht zwei Bilder im Speicher.                                        *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 30.09.1992                                               *
* Letzte Aenderung: 10.10.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input:  BildNr1 = Quellbild                                                *
*         BildNr2 = Zielbild                                                 *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(), Show_Pic()         *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Swap_Picture(int BildNr1, int BildNr2)
{
  int Dummy;                                  /* Hilfsvariable              */
  long z, s;                                  /* Zeilen- und Spaltenzaehler */
  unsigned char Pixel;                        /* Grauwert eines Pixels      */
  long Index1, Index2;                        /* Adressen der beiden Bilder */

  /* Titel nur anzeigen, falls keine Bildnummern angegeben wurden           */
  if ((BildNr1==FALSE) || (BildNr2==FALSE)) {
     ClearTextWindow(35,18,80,25);
     WriteText(35,18,"* Zwei Bilder vertauschen *");
  }

  if (BildNr1 == FALSE) {
     gotoxy(35,20);
     BildNr1=Read_Int("Bild Nr. 1 ", 1, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */

  if (BildNr2 == FALSE) {
     gotoxy(35,21);
     BildNr2=Read_Int("Bild Nr. 2 ", 2, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt bei immer 0 an */

  Index1 = (long) (BildNr1) * PIC_SIZE; /* Anfangsadresse der beiden Bilder */
  Index2 = (long) (BildNr2) * PIC_SIZE;

  /* Die beiden Bilder vertauschen und danach noch die ...                  */
  for (s=0; s<PIC_SIZE; s++) {
      Pixel=Pictures[Index1];
      Pictures[Index1++]=Pictures[Index2];
      Pictures[Index2++]=Pixel;
  }

  /* ... Bildinformation vertauschen (Bilder duerfen auch unbenutzt sein)   */
  Dummy=Bild[BildNr1].Zeilen;
  Bild[BildNr1].Zeilen =Bild[BildNr2].Zeilen;
  Bild[BildNr2].Zeilen =Dummy;

  Dummy=Bild[BildNr1].Spalten;
  Bild[BildNr1].Spalten=Bild[BildNr2].Spalten;
  Bild[BildNr2].Spalten=Dummy;

  Dummy=Bild[BildNr1].Used;
  Bild[BildNr1].Used   =Bild[BildNr2].Used;
  Bild[BildNr2].Used   =Dummy;

  Dummy=Bild[BildNr1].Color;
  Bild[BildNr1].Color  =Bild[BildNr2].Color;
  Bild[BildNr2].Color  =Dummy;

  /* Zum Schluss nur noch die Icons vertauschen und ...                     */
  for (z=0; z<ICON_SIZE; z++)
      for (s=0; s<ICON_SIZE; s++) {
          Dummy=Bild[BildNr1].Icon[z][s];
          Bild[BildNr1].Icon[z][s]=Bild[BildNr2].Icon[z][s];
          Bild[BildNr2].Icon[z][s]=Dummy;
      }

  /* ... die Bilder komplett anzeigen.                                      */
  Show_Pic(BildNr1, BildNr1+1);
  Show_Pic(BildNr2, BildNr2+1);

}
